---
image: registry.gitlab.com/aplus-framework/images/base:2

include:
  - template: Security/SAST.gitlab-ci.yml

variables:
  SAST_EXCLUDED_PATHS: guide, tests, vendor

test:php:
  stage: test
  timeout: 10 minutes
  cache:
    paths:
      - build/
      - vendor/
  services:
    - mariadb
  variables:
    MYSQL_DATABASE: framework-tests
    MYSQL_ROOT_PASSWORD: password
  before_script:
    - php -v
    - composer update
  script:
    - composer normalize --dry-run --indent-size=4 --indent-style=space
    - vendor/bin/php-cs-fixer fix --diff --dry-run --verbose
    - vendor/bin/phpmd src xml phpmd.xml
    - vendor/bin/phpstan analyse -vvv
    - vendor/bin/phpunit --colors=never
    - phpdoc
  artifacts:
    paths:
      - build/coverage/
      - build/docs/
  coverage: '/^\s*Lines:\s*\d+.\d+\%/'

test:php-last:
  image: registry.gitlab.com/aplus-framework/images/base:3
  stage: test
  timeout: 10 minutes
  cache:
    paths:
      - vendor/
  services:
    - mariadb
  variables:
    MYSQL_DATABASE: framework-tests
    MYSQL_ROOT_PASSWORD: password
  before_script:
    - php -v
    - composer update
  script:
    - vendor/bin/phpunit --colors=never
  coverage: '/^\s*Lines:\s*\d+.\d+\%/'

pages:
  stage: deploy
  timeout: 10 minutes
  dependencies:
    - test:php
  environment:
    name: production
    url: https://aplus-framework.gitlab.io
  script:
    - mkdir public/
    - mv build/coverage/ public/
    - mv build/docs/ public/
  artifacts:
    paths:
      - public/
  only:
    - master
